// testDlg.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "testDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// This is the globally unique identifier for the HAWin32 class.
// We need it to create an HAWin32 object.
//
CLSID g_CLSID_HAWin32 =
{0x5178cce0, 0xaaef, 0x11ce, {0xae, 0x75, 0x0, 0xaa, 0x0, 0x30, 0xeb, 0xc8}};

// This is the globally unique identifier for the HAWin32 interface.
// We need it to get an interface to our HAWin32 object.
//
IID g_IID_HAWin32 =
{0x5178cce2, 0xaaef, 0x11ce, {0xae, 0x75, 0x0, 0xaa, 0x0, 0x30, 0xeb, 0xc8}};
	

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent),
      m_pUnknown(0),
      m_pHAWin32(0),
      m_pHAScript(0)
{
	//{{AFX_DATA_INIT(CTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnhaType)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CreateHAScriptObject();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestDlg::OnhaType() 
{
	haTypeText("This is a test");
}

long CTestDlg::haTypeText(const CString &rcs)
{
	// What makes things easy for VB programmers makes things hard for C++
	// programmers.  haTypeText uses variants so that the arguments can be
	// optional.  So here's a wrapper that makes calling haTypeText easier.
	//
	long lRet;
	COleVariant ocovString(rcs); // Important, strings must be BSTR.  CString does this for us.
	COleVariant ocovLength;		 // Must be an empty variant if first par is a string.

	switch ((lRet = m_pHAScript->haTypeText(ocovString, ocovLength)))
	{
	#define HA_ERR_OK 0
	#define HA_ERR_CONNECTION_LOST -8

	case HA_ERR_OK:
		AfxMessageBox(IDS_IT_WORKS);
		break;

	case HA_ERR_CONNECTION_LOST:
		AfxMessageBox(IDS_GET_CONNECTED_DUDE);
		break;

	default:
		AfxMessageBox(IDS_FAILED);
		break;
	};

	return lRet;
}

BOOL CTestDlg::CreateHAScriptObject(void)
{
    LPDISPATCH lpdHAWin32;
    LPDISPATCH lpdHAScript;

    // Get the active instance of HAWin32.
	// You could do a CoCreateInstance() here as well and then
	// HyperACCESS would activate automatically.
    //
    if ( GetActiveObject(g_CLSID_HAWin32, NULL, &m_pUnknown) != S_OK )
        {
        AfxMessageBox(IDS_HAWIN32_NOT_ACTIVE);
        return FALSE;
        }

    // Query the dispatch interface for HAWin32.
    //
    if ( m_pUnknown->QueryInterface(g_IID_HAWin32, (void **)&lpdHAWin32) != S_OK )
        {
        AfxMessageBox(IDS_QUERYINTERFACE_FAILED);
        return FALSE;
        }

    // Create our HAWin32 interface.
    //
    m_pHAWin32 = new IHyperACCESS(lpdHAWin32);

    if ( m_pHAWin32 == 0 )
        {
        AfxMessageBox(IDS_HAWIN32_NEW_FAILED);
        return FALSE;
        }

    // Get the dispatch interface for HAScript.
    //
    lpdHAScript = m_pHAWin32->haInitialize("Test");

    // Create our HAScript interface.
    //
    m_pHAScript = new IHAScript(lpdHAScript);

    if ( m_pHAScript == 0 )
        {
        AfxMessageBox(IDS_HAWIN32_NEW_FAILED);
        return FALSE;
        }

	return TRUE;
}


void CTestDlg::ReleaseHAScriptObject(void)
    {
    if ( m_pHAScript )
        {
        // Terminate the script.
        //
        m_pHAScript->haTerminate();

        // We're done with the HAScript object.
        //
        m_pHAScript->ReleaseDispatch();
        delete m_pHAScript;
        }

    if ( m_pHAWin32 )
        {
        // We're done with the HAWin32 object.
        //
        m_pHAWin32->ReleaseDispatch();
        delete m_pHAWin32;
        }

    if ( m_pUnknown )
        {
        // We're done with the IUnknown interface.
        m_pUnknown->Release();
        }
    }

void CTestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
		
	ReleaseHAScriptObject();
}
