// Machine generated IDispatch wrapper class(es) created with ClassWizard
/////////////////////////////////////////////////////////////////////////////
// IHyperACCESS wrapper class

class IHyperACCESS : public COleDispatchDriver
{
public:
	IHyperACCESS() {}		// Calls COleDispatchDriver default constructor
	IHyperACCESS(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IHyperACCESS(const IHyperACCESS& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
	LPDISPATCH haInitialize(LPCTSTR lpctstrName);
};
/////////////////////////////////////////////////////////////////////////////
// IHAScript wrapper class

class IHAScript : public COleDispatchDriver
{
public:
	IHAScript() {}		// Calls COleDispatchDriver default constructor
	IHAScript(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IHAScript(const IHAScript& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
	long haTerminate();
	long haTypeText(const VARIANT& v_nSize, const VARIANT& v_pszPtr);
	long haConnectSession(long nMode);
	long haGetConnectionStatus();
	long haSizeHyperACCESS(long nMode);
	long haDisconnectSession();
	long haSleep(long lTime);
	long haWaitForConnection(long nStatus, long lTimeout);
	long haOpenSession(LPCTSTR pszName);
	long haWait(long lTimeout);
	long haBlockRemoteInput();
	long haReleaseRemoteInput();
	long haWaitForActivity(long lTimeout);
	long haWaitForLines(long nLines, long lTimeout);
	long haWaitForLull(long lPause, long lTimeout);
	long haWaitForXfer(long lTimeout);
	long haSetRuntimeValue(long lValue, LPCTSTR pszBuffer);
	long haSetSessionDataString(short nIndex, LPCTSTR pszPtr);
	CString haGetRuntimeValue(long lValue, const VARIANT& v_fPrompt);
	CString haGetSessionDataString(short nIndex);
	CString haGetNameString();
	long haGetConnectTime();
	long haConnectAndDial(long lMode, LPCTSTR pszNumber);
	long haGetBaudRate();
	long haSetBaudRate(long lSpeed);
	long haGetPortMode();
	long haSetPortMode(long lMode);
	CString haGetPortName();
	long haSpawn(LPCTSTR pszName);
	CString haComDriverSpecial(LPCTSTR pszCmd);
	long haCreateConnection(LPCTSTR pszDetails);
	long haDeleteConnection(long hCnctKey);
	CString haFindComTypes(long lFindFlag, long lCompatibility);
	CString haFindComTypeDevices(long lFindFlag);
	long haFindConnection(long lFindFlag);
	CString haFindConnectionTypeDevices(long lFindFlag);
	long haClearXferSendList();
	long haGetXferFinalStatus();
	long haGetXferParameters();
	long haGetXferProtocol(long lDirection);
	long haGetXferStatus();
	long haSetAdlOverride(long lFlag);
	long haSetXferDirectory(long lDirection, LPCTSTR pszPtr);
	long haSetXferParameters(long lParams);
	long haSetXferProtocol(long lDirection, long lProtocol);
	long haTextSend(LPCTSTR pszFileName);
	long haXferAddToSendList(LPCTSTR pszName);
	long haXferReceive(LPCTSTR pszName, const VARIANT& v_fWait);
	long haXferSend(LPCTSTR pszName, long lFlag);
	long haXferSendBatch(LPCTSTR pszName, long lFlag);
	long haXferSendFromList(const VARIANT& v_fWait);
	long haXferSendList(LPCTSTR pszPtr, long lFlag);
	CString haGetXferDirectory(long lDirection);
	CString haGetXferSendList(long lIndex);
	CString haGetConnectionDetails(long hCnctKey);
	long haGetCurrentConnection();
	long haGetDefaultConnection();
	CString haGetDialingPrefix(short nIndex);
	CString haGetPortType();
	long haGetRingsForAnswer();
	long haSelectDialingPrefix(short nIndex);
	long haSetConnectionDetails(long hCnctKey, LPCTSTR pszDetails);
	long haSetCurrentConnection(long hCnctKey);
	long haSetDialingPrefix(short nIndex, LPCTSTR pszPtr);
	long haSetPortName(LPCTSTR pszPtr);
	long haSetPortType(LPCTSTR pszPtr);
	long haSetPulseTone(long lMode);
	long haSetRingsForAnswer(short nCount);
	CString haGetSerNumString();
	CString haGetVersion();
	long haSetNameString(LPCTSTR pszPtr);
	long haGetWindowStateBits();
	long haMenuString(LPCTSTR pszString);
	long haSetMessageTimer(long lSeconds);
	long haSizePhonebook(long lMode);
	long haSizeSession(long lMode);
	long haClearOutputBuffer();
	long haTypeLocalText(const VARIANT& v_nSize, const VARIANT& v_pszPtr);
	long haWaitForOutputDone(long lTimeout);
	CString haGetInput(long lMode, long lCount, long lStartTimeout, long lCharTimeout);
	long haCloseSession();
	long haCreateNewSession(LPCTSTR pszName);
	long haGetOpenSession(short nIndex);
	long haGetSession();
	CString haGetSessionName();
	long haSetSession(long hSession);
	long haClearXferDropList();
	CString haGetXferDropList(short nIndex);
	long haXferDropSend(long lFlag);
	long haCaptureBegin(const VARIANT& v_lMode, const VARIANT& v_lAppend);
	long haCaptureControl(long lFunction);
	long haCaptureToPrinterBegin(long lMode, long lMethod);
	long haCaptureToPrinterControl(long lFunction);
	CString haGetCaptureFileName();
	CString haGetLogFileName();
	long haGetPrinterStatus();
	long haSetCaptureFileName(LPCTSTR pszPtr);
	long haSetLogFileName(LPCTSTR pszPtr);
	long haSetLogonTask(LPCTSTR pszPtr);
	long haWriteLogEntry(LPCTSTR pszPtr);
	CString haGetLearnFileName();
	long haLearnControl(long lCmd);
	long haSetLearnFileName(LPCTSTR pszPtr);
	long haGetDisplay();
	CString haGetPhonebookEntry(short nIndex);
	long haReloadPhonebook();
	long haSavePhonebook();
	long haSetDisplay(long lMode);
	CString haGetEmulator();
	CString haGetSelectedText();
	CString haGetTextFromScreen(long lRow, long lCol, long lCount);
	long haSetCursorPosition(long lRow, long lCol);
	long haSetEcho(long lEcho);
	long haSetEmulator(LPCTSTR pszPtr);
	long haSetLocalDisplay(long lFlag);
	long haSetLocalEcho(long lEcho);
	long haSetStripTo7Bits(long lStrip);
	long haRestrictMenus(BOOL fRestrict);
	CString haDialogBox(LPCTSTR pszTitle, LPCTSTR pszMessage, long lButtons);
	long haGetCursorRow();
	long haGetCursorColumn();
	long haGetAsciiFlags();
	long haGetAsciiOutputTabSpaces();
	long haGetAsciiCharDelay();
	long haGetAsciiInputTabSpaces();
	long haSetAsciiCharDelay(long lDelay);
	long haSetAsciiFlags(long lFlags);
	long haSetAsciiInputTabSpaces(long lSpaces);
	long haSetAsciiOutputTabSpaces(long lSpaces);
	long haSetAsciiLineDelay(long lDelay);
	long haGetAsciiLineDelay();
	long haFindConnectionType(long lFindFlag);
	CString haGetConnectionTypeName();
	long haGetConnectionTypeFlags();
	long haGetAsciiWaitForChar();
	long haSetAsciiWaitForChar(long lChar);
	long haMessageBox(LPCTSTR pszTitle, LPCTSTR pszMessage, long lButtons);
	long haGetLastError();
	long haWaitForPrompt(LPCTSTR pszPrompt, const VARIANT& v_lPause, const VARIANT& v_lTimeout);
	long haAddMultiPrompt(LPCTSTR pszPrompt);
	long haClearMultiPrompt();
	long haWaitForMultiPrompt(long lPause, long lTimeout);
	long haWaitForString(LPCTSTR pszString, const VARIANT& v_lTimeout);
	long haTypeKey(LPCTSTR pszPtr);
	LPDISPATCH haCreateObject(LPCTSTR pszProgID);
	long haAbortOnError(const VARIANT& v_fEnable);
};
/////////////////////////////////////////////////////////////////////////////
// IHAScriptEvents wrapper class

class IHAScriptEvents : public COleDispatchDriver
{
public:
	IHAScriptEvents() {}		// Calls COleDispatchDriver default constructor
	IHAScriptEvents(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IHAScriptEvents(const IHAScriptEvents& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
	void Init();
	void OnTransferBegin();
	void OnTransferEnd();
	void OnBeforeConnect();
	void OnAfterConnect();
	void OnDisconnect();
};
/////////////////////////////////////////////////////////////////////////////
// IHCLocateOLE wrapper class

class IHCLocateOLE : public COleDispatchDriver
{
public:
	IHCLocateOLE() {}		// Calls COleDispatchDriver default constructor
	IHCLocateOLE(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IHCLocateOLE(const IHCLocateOLE& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
};
