// testDlg.h : header file
//

#include "hawin32.h"

#if !defined(AFX_TESTDLG_H__88F2CF86_A525_11D0_AEA0_00AA0018F4F1__INCLUDED_)
#define AFX_TESTDLG_H__88F2CF86_A525_11D0_AEA0_00AA0018F4F1__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

class CTestDlg : public CDialog
{
// Construction
public:
	CTestDlg(CWnd* pParent = NULL);	// standard constructor

	BOOL CreateHAScriptObject(void);
	void ReleaseHAScriptObject(void);
	long haTypeText(const CString &rcs);

protected:
    IUnknown*     m_pUnknown;  // HAWIn32's unknown interface.
    IHyperACCESS* m_pHAWin32;  // Interface to HAWin32.
    IHAScript*    m_pHAScript; // Interface to an HAWin32 script.

public:
// Dialog Data
	//{{AFX_DATA(CTestDlg)
	enum { IDD = IDD_TEST_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnhaType();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTDLG_H__88F2CF86_A525_11D0_AEA0_00AA0018F4F1__INCLUDED_)
